using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Threading;
using ff14bot;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using Newtonsoft.Json;

namespace FateAutoLeveler
{
    public class FateAutoLeveler : IBotPlugin
    {
        #region Necessary Stuff
        public string Author { get { return "Zamphire"; } }
        public Version Version { get { return new Version(1, 0); } }
        public string Name { get { return "Fate Auto Leveler"; } }
        public string Description { get { return "Moves your character to appropriate level range."; } }
        public bool WantButton
        {
            get { return false; }
        }
        public string ButtonText
        {
			get { return "FateAutoLeveler"; }
        }
        public void OnButtonPress()
        {
 
        }
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }
        #endregion
        public void OnPulse()
        {
            if (BotManager.Current.Name == "Fate Bot")
            {
                ChangeZone();
            }
        }

        public void OnInitialize()
        {

        }
        public void OnShutdown()
        {

        }
        public void OnEnabled()
        {

        }
        public void OnDisabled()
        {

        }

        #region Atmas
        public void ChangeZone()
        {
            #region Change zones
                if (NextLocation() == "None")
                {
                    Logging.Write("You don't have the Aetheryte for this level range.");
                    return;
                }

                if (CurrentLocation(WorldManager.ZoneId) == NextLocation())
                {
                    return;
                }

                TreeRoot.Stop();

                if (Core.Player.IsMounted)
                {
                    Actionmanager.Dismount();
                    Thread.Sleep(1000);
                }

                if (CurrentLocation(WorldManager.ZoneId) != NextLocation())
                {
                    Logging.Write("[FateBot] Moving to " + NextLocation());
                    if (NextLocation() == "The Hawthorne Hut")
                        WorldManager.TeleportById(4);
                    else
                        WorldManager.Teleport(NextLocation());
                    Thread.Sleep(15000);
                    TreeRoot.Start();

                }
            

            #endregion
        }

		
        public string NextLocation()
        {
            string zone = null;
			
			var currentLevel = (int)Core.Player.ClassLevel;
			
			if (currentLevel >= 1 && currentLevel < 15)
            {
                zone = "1thru15";
            }
            if (currentLevel >= 15 && currentLevel < 20)
            {
                zone = "15thru20";
            }
            if (currentLevel >= 20 && currentLevel < 25)
            {
                zone = "20thru25";
            }
            if (currentLevel >= 25 && currentLevel < 30)
            {
                zone = "25thru30";
            }
            if (currentLevel >= 30 && currentLevel < 35)
            {
                zone = "30thru35";
            }
            if (currentLevel >= 35 && currentLevel < 40)
            {
                zone = "35thru40";
            }
            if (currentLevel >= 40 && currentLevel < 50)
            {
                zone = "40thru50";
            }
//
//            foreach (BagSlot a in InventoryManager.Slots)
  //          {
    //            Inventory.Add(a.Name);
      //      }
//
  //          if (!Inventory.Contains(jstAtma))
    //        {
      //          return GetLocationName(jstAtma);
        //    }
//
  //          foreach (string a in Atmas)
    //        {
      //          if (!Inventory.Contains(a))
        //            atma = a;
          //  }
//
  //          return GetLocationName(zone);
			return GetLocationName(zone);
        }

        private static string GetLocationName(string zone)
        {
            switch (zone)
            {
                case "1thru15":
                    return "Summerford Farms";//134;

                case "15thru20":
                    return "Aleport";//138;

                case "20thru25":
                    return "Camp Drybone";//145;

                case "25thru30":
                    return "Quarrymill";//153;

                case "30thru35":
                    return "Costa del Sol";//137;

                case "35thru40":
                    return "Camp Bronze Lake";//139;

                case "40thru50":
                    return "Camp Dragonhead";//155;

                default:
                    return "None";
            }
        }
        public string CurrentLocation(uint zoneid)
        {
            switch (zoneid)
            {
                case 152:
                    return "The Hawthorne Hut";//152;
					
				case 153:
					return "Quarrymill";//153;
					
                case 145:
                    return "Camp Drybone";//145;

                case 140:
                    return "Horizon";//140;

                case 139:
                    return "Camp Bronze Lake";//139;

                case 134:
                    return "Summerford Farms";//134;

                case 138:
                    return "Aleport";//138;
					
				case 137:
					return "Costa del Sol";//137;
					
				case 155:
					return "Camp Dragonhead";//155;

                default:
                    return "None";
            }
        }

        #endregion
    }
 }

